Statistics
| Branch: | Revision:

root / create @ cc927a76

History | View | Annotate | Download (2.9 kB)

1 79224631 Lance Albertson
#!/bin/bash
2 79224631 Lance Albertson
3 f1afb4b1 Lance Albertson
# Copyright (C) 2010 Oregon State University
4 79224631 Lance Albertson
#
5 79224631 Lance Albertson
# This program is free software; you can redistribute it and/or modify
6 79224631 Lance Albertson
# it under the terms of the GNU General Public License as published by
7 79224631 Lance Albertson
# the Free Software Foundation; either version 2 of the License, or
8 79224631 Lance Albertson
# (at your option) any later version.
9 79224631 Lance Albertson
#
10 79224631 Lance Albertson
# This program is distributed in the hope that it will be useful, but
11 79224631 Lance Albertson
# WITHOUT ANY WARRANTY; without even the implied warranty of
12 79224631 Lance Albertson
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
13 79224631 Lance Albertson
# General Public License for more details.
14 79224631 Lance Albertson
#
15 79224631 Lance Albertson
# You should have received a copy of the GNU General Public License
16 79224631 Lance Albertson
# along with this program; if not, write to the Free Software
17 79224631 Lance Albertson
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
18 79224631 Lance Albertson
# 02110-1301, USA.
19 79224631 Lance Albertson
20 79224631 Lance Albertson
set -e
21 79224631 Lance Albertson
22 611fa6b0 Lance Albertson
if [ "${IMAGE_DEBUG} " = 1 ] ; then
23 e84e87cd Lance Albertson
    set -x
24 e84e87cd Lance Albertson
fi
25 e84e87cd Lance Albertson
26 79224631 Lance Albertson
. common.sh
27 79224631 Lance Albertson
28 baca98f3 Lance Albertson
IMAGE_FILE=""
29 baca98f3 Lance Albertson
if [ "$IMAGE_TYPE" = "tarball" ] ; then
30 baca98f3 Lance Albertson
    IMAGE_FILE="${IMAGE_DIR}/${IMAGE_NAME}-${ARCH}.tar.gz"
31 baca98f3 Lance Albertson
elif [ "$IMAGE_TYPE" = "qemu" ] ; then
32 baca98f3 Lance Albertson
    IMAGE_FILE="${IMAGE_DIR}/${IMAGE_NAME}-${ARCH}.img"
33 baca98f3 Lance Albertson
fi
34 134c11c3 Lance Albertson
35 fcce5224 Lance Albertson
if [ "$CDINSTALL" = "no" ] ; then
36 fcce5224 Lance Albertson
    # If the target device is not a real block device we'll first losetup it.
37 fcce5224 Lance Albertson
    # This is needed for file disks.
38 fcce5224 Lance Albertson
    if [ ! -b $blockdev ]; then
39 fcce5224 Lance Albertson
      ORIGINAL_BLOCKDEV=$blockdev
40 fcce5224 Lance Albertson
      blockdev=$($LOSETUP -sf $blockdev)
41 fcce5224 Lance Albertson
      CLEANUP+=("$LOSETUP -d $blockdev")
42 fcce5224 Lance Albertson
    fi
43 fcce5224 Lance Albertson
44 b05b1ab6 Lance Albertson
    if [ ! -f "$IMAGE_FILE" ] ; then
45 b05b1ab6 Lance Albertson
      log_error "Can't find image file: $IMAGE_FILE"
46 b05b1ab6 Lance Albertson
      exit 1
47 b05b1ab6 Lance Albertson
    fi
48 b05b1ab6 Lance Albertson
49 b05b1ab6 Lance Albertson
    # If the image is tarball based, then we need to manually create the
50 b05b1ab6 Lance Albertson
    # volumes, filesystems, etc
51 b05b1ab6 Lance Albertson
    if [ "${IMAGE_TYPE}" = "tarball" ] ; then
52 b05b1ab6 Lance Albertson
        # Create 3 partitions, /boot, swap, & /
53 b05b1ab6 Lance Albertson
        format_disk0 $blockdev
54 b05b1ab6 Lance Albertson
    elif [ "${IMAGE_TYPE}" = "qemu" ] ; then
55 b05b1ab6 Lance Albertson
        # need a recent version of qemu for this
56 ab712029 Lance Albertson
        ${QEMU_IMG} convert ${IMAGE_FILE} -O host_device ${blockdev}
57 b05b1ab6 Lance Albertson
    fi
58 b05b1ab6 Lance Albertson
59 a1d43218 Lance Albertson
    filesystem_base_dev=$(map_disk0 $blockdev)
60 e21b8802 Lance Albertson
    if [ "${SWAP}" = "yes" ] ; then
61 e21b8802 Lance Albertson
        boot_dev="${filesystem_base_dev}-1"
62 e21b8802 Lance Albertson
        swap_dev="${filesystem_base_dev}-2"
63 e21b8802 Lance Albertson
        root_dev="${filesystem_base_dev}-3"
64 e21b8802 Lance Albertson
    else
65 e21b8802 Lance Albertson
        boot_dev="${filesystem_base_dev}-1"
66 e21b8802 Lance Albertson
        root_dev="${filesystem_base_dev}-2"
67 e21b8802 Lance Albertson
    fi
68 a1d43218 Lance Albertson
    CLEANUP+=("unmap_disk0 $blockdev")
69 fcce5224 Lance Albertson
70 b05b1ab6 Lance Albertson
    if [ "${IMAGE_TYPE}" = "tarball" ] ; then
71 cc927a76 Lance Albertson
        mkfs_disk0 $boot_dev $root_dev $swap_dev
72 b05b1ab6 Lance Albertson
    fi
73 fcce5224 Lance Albertson
74 916b6dd1 Lance Albertson
    TARGET=`mktemp -d` || exit 1
75 916b6dd1 Lance Albertson
    CLEANUP+=("rmdir $TARGET")
76 fcce5224 Lance Albertson
77 a1d43218 Lance Albertson
    # mount filesystems
78 916b6dd1 Lance Albertson
    mount_disk0 $TARGET $root_dev $boot_dev
79 b05b1ab6 Lance Albertson
80 b05b1ab6 Lance Albertson
    if [ "${IMAGE_TYPE}" = "tarball" ] ; then
81 b05b1ab6 Lance Albertson
        # unpack image
82 916b6dd1 Lance Albertson
        tar pzxf $IMAGE_FILE -C $TARGET
83 b05b1ab6 Lance Albertson
    fi
84 e5ec11e4 Lance Albertson
85 fcce5224 Lance Albertson
    RUN_PARTS=`which run-parts`
86 fcce5224 Lance Albertson
87 fcce5224 Lance Albertson
    if [ -n "$RUN_PARTS" -a -n "$CUSTOMIZE_DIR" -a -d "$CUSTOMIZE_DIR" ]; then
88 916b6dd1 Lance Albertson
      TARGET=$TARGET
89 fcce5224 Lance Albertson
      BLOCKDEV=$blockdev
90 f7959feb Lance Albertson
      ROOT_DEV=$root_dev
91 c29e092d Lance Albertson
      BOOT_DEV=$boot_dev
92 e0f1ce56 Lance Albertson
      export TARGET SUITE BLOCKDEV ROOT_DEV BOOT_DEV
93 fcce5224 Lance Albertson
      $RUN_PARTS $CUSTOMIZE_DIR
94 fcce5224 Lance Albertson
    fi
95 79224631 Lance Albertson
fi
96 79224631 Lance Albertson
97 79224631 Lance Albertson
# execute cleanups
98 79224631 Lance Albertson
cleanup
99 79224631 Lance Albertson
trap - EXIT
100 79224631 Lance Albertson
101 79224631 Lance Albertson
exit 0